#include "LPM.h"

//#define _MASU_DEBAG_

#ifdef _MASU_DEBAG_
#include "cv.h"
#include "highgui.h"
#include "cxcore.h"
#endif

LPM::LPM(int Xmin,int Xmax,int Ymin,int Ymax,int Grid_size){
	
	this->Xmin=Xmin;
	this->Xmax=Xmax;
	this->Ymax=Ymax;
	this->Ymin=Ymin;
	this->Grid_size=Grid_size;

	XMapSize   = Xmax - Xmin;
	YMapSize   = Ymax - Ymin;
	Pose_theta = 0.0;
	Pose_x     = 0.0;
	Pose_y     = 0.0;
	
	int Xnum = XMapSize / Grid_size;

	int Ynum = YMapSize / Grid_size;

	map=new double* [Xnum];
	
	for(int i=0;i<Xnum;i++){
		map[i]=new double[Ynum];
		for(int j=0;j<Ynum;j++)
			map[i][j]=0.5;
	}
	
	
	work_map=new double* [Xnum];
	flag=new int* [Xnum];
	for(int i=0;i<Xnum;i++){
		work_map[i] =new double[Ynum];
		flag[i] =new int[Ynum];
	}

#if 1
	//ʒuӂ̓t[Ƃ
	for(int i=0;i<Xnum;i++){
		for(int j=0;j<Ynum;j++){
			if((i-Xnum/2)*(i-Xnum/2)+(j-Ynum/2)*(j-Ynum/2)<(500/Grid_size)*(500/Grid_size)){
				map[i][j]=0;
			}
		}
	}
	
#endif
}
LPM::~LPM(){
	int Xnum=XMapSize/Grid_size;
	int Ynum=YMapSize/Grid_size;
	for(int i=0;i<Xnum;i++){
		delete[] map[i];
		delete[] work_map[i];
		delete[] flag[i];
	}
	delete[] map;
	delete[] work_map;
	delete[] flag;
}

double LPM::POE(double dist){return 0.8;}
double LPM::P_OE(double dist){return 1-POE(dist);}
double LPM::PO_E(double dist){return 0.05;}
double LPM::P_O_E(double dist){return 1-PO_E(dist);}

/*
p_diff͑Έړʂł邱Ƃɒ
܂{bgʕxƂĂ
*/
void LPM::MapUpdate(Pose p_diff,double *dist,double theta_start,double theta_end,int data_num,double min_dist,double max_dist,Pose sensor){

	int i,j;
	int Xnum=XMapSize/Grid_size;
	int Ynum=YMapSize/Grid_size;
#if 0
	double work_map[Xnum][Ynum];
	int flag[Xnum][Ynum]={{0}};
#endif
	
	for(int i=0;i<Xnum;i++){
		for(int j=0;j<Ynum;j++){
			flag[i][j]=0;
		}
	}
	
	theta_start*=(M_PI/180.0);
	theta_end*=(M_PI/180.0);


	/*}bv̈ړ*/
	for(i=0;i<Xnum;i++){
		for(j=0;j<Ynum;j++){
			work_map[i][j]=map[i][j];
		}
	}

	double cosdt=cos(p_diff.theta);
	double sindt=sin(p_diff.theta);
	//oCjA⊮
	for(i=0;i<Xnum;i++){
		for(j=0;j<Ynum;j++){

			#if 0
			double xo=cosdt*(double)(i-Map_size/Grid_size/2)-sindt*(double)(j-Map_size/Grid_size/2)+p_diff.y/(double)Grid_size+Map_size/Grid_size/2;//p.diff̕ςȂ̂p_diff̓{bgWnmap̓}bvWn̂
			double yo=sindt*(double)(i-Map_size/Grid_size/2)+cosdt*(double)(j-Map_size/Grid_size/2)-p_diff.x/(double)Grid_size+Map_size/Grid_size/2;
#else
			double xo=cosdt*(double)(i-XMapSize/Grid_size/2)-sindt*(double)(j-YMapSize/Grid_size/2)+p_diff.x/(double)Grid_size+XMapSize/Grid_size/2;//p.diff̕ςȂ̂p_diff̓{bgWnmap̓}bvWn̂
			double yo=sindt*(double)(i-XMapSize/Grid_size/2)+cosdt*(double)(j-YMapSize/Grid_size/2)+p_diff.y/(double)Grid_size+YMapSize/Grid_size/2;
#endif
			double wsum=0.0;
			double w=0.0;

			int x_ix,y_ix;

#if  1
			if(fabs(floor(xo)-ceil(xo))<1e-6){
				xo+=1e-4;
			}
			if(fabs(floor(yo)-ceil(yo))<1e-6){
				yo+=1e-4;
			}


			x_ix=(int)floor(xo);
			y_ix=(int)floor(yo);
			if(x_ix>=0 && x_ix<Xnum && y_ix>=0 && y_ix<Ynum){
				wsum+=(ceil(xo)-xo)*(ceil(yo)-yo)*work_map[x_ix][y_ix];
			}else{
				wsum+=(ceil(xo)-xo)*(ceil(yo)-yo)*0.5;
			}
			w+=(ceil(xo)-xo)*(ceil(yo)-yo);

			x_ix=(int)ceil(xo);
			y_ix=(int)floor(yo);
			if(x_ix>=0 && x_ix<Xnum && y_ix>=0 && y_ix<Ynum){
				wsum+=(xo-floor(xo))*(ceil(yo)-yo)*work_map[x_ix][y_ix];
			}else{
				wsum+=(xo-floor(xo))*(ceil(yo)-yo)*0.5;
			}
			w+=(xo-floor(xo))*(ceil(yo)-yo);


			x_ix=(int)floor(xo);
			y_ix=(int)ceil(yo);
			if(x_ix>=0 && x_ix<Xnum && y_ix>=0 && y_ix<Ynum){
				wsum+=(ceil(xo)-xo)*(yo-floor(yo))*work_map[x_ix][y_ix];
			}else{
				wsum+=(ceil(xo)-xo)*(yo-floor(yo))*0.5;
			}
			w+=(ceil(xo)-xo)*(yo-floor(yo));


			x_ix=(int)ceil(xo);
			y_ix=(int)ceil(yo);
			if(x_ix>=0 && x_ix<Xnum && y_ix>=0 && y_ix<Ynum){
				wsum+=(xo-floor(xo))*(yo-floor(yo))*work_map[x_ix][y_ix];
			}else{
				wsum+=(xo-floor(xo))*(yo-floor(yo))*0.5;
			}
			w+=(xo-floor(xo))*(yo-floor(yo));

			//map[i][j]=wsum/w;

#endif

			#if 0
			if(0){
				printf("%lf %lf %e %e %e %e\n"
					,xo,yo
					,(ceil(xo)-(xo))*(ceil(yo)-(yo)),(xo-floor(xo))*(ceil(yo)-(yo))
					,(ceil(xo)-(xo))*(yo-floor(yo)),(xo-floor(xo))*(yo-floor(yo)));
			}
			#endif
			map[i][j]=wsum/w;
		}
	}
#if 0
	for(i=0;i<Map_size/Grid_size;i++)for(j=0;j<Map_size/Grid_size;j++)flag[i][j]=0;

	//printf("update P(E|O)\n");

	/*QʒũAbvf[g*/
	for(i=0;i<data_num;i++){
		if(dist[i]<0)continue;
		if(fabs(dist[i]-max_dist)<1e-6)continue;

		double obs_theta=theta_start+(theta_end-theta_start)/(double)(data_num-1)*(double)i+sensor.theta;
		int x_ix=(int)(dist[i]*cos(obs_theta)/Grid_size+Map_size/Grid_size/2+sensor.x/Grid_size);
		int y_ix=(int)(dist[i]*sin(obs_theta)/Grid_size+Map_size/Grid_size/2+sensor.y/Grid_size);
		if(x_ix>=0 && x_ix<Map_size/Grid_size && y_ix>=0 && y_ix<Map_size/Grid_size){
			if(flag[x_ix][y_ix]==1) continue;

			double work=map[x_ix][y_ix];
			if(work<0.01) work=0.01;

			map[x_ix][y_ix]=POE(dist[i])*work/(POE(dist[i])*work+PO_E(dist[i])*(1-work));
			flag[x_ix][y_ix]=1;
		}
	}

	/*RԃAbvf[g*/

	//printf("update P(E|O~)\n");

	for(i=0;i<data_num;i++){
		if(dist[i]<0)continue;

		double obs_theta=theta_start+(theta_end-theta_start)/(double)(data_num-1)*(double)i+sensor.theta;
		double x=0;
		double y=0;
		double dx=cos(obs_theta)*Grid_size/10;
		double dy=sin(obs_theta)*Grid_size/10;
		while( fabs(dist[i]-sqrt(x*x+y*y)) >Grid_size/2 ){
			int x_ix=(int)(x/Grid_size+Map_size/Grid_size/2+sensor.x/Grid_size);
			int y_ix=(int)(y/Grid_size+Map_size/Grid_size/2+sensor.y/Grid_size);
			if(x_ix>=0 && x_ix<Map_size/Grid_size && y_ix>=0 && y_ix<Map_size/Grid_size){

				if(flag[x_ix][y_ix]==1){
					x+=dx;
					y+=dy;
					continue;
				}

				double work=map[x_ix][y_ix];
				if(work>0.99)work=0.99;
				map[x_ix][y_ix]=P_OE(sqrt(x*x+y*y))*work/(P_OE(sqrt(x*x+y*y))*work+P_O_E(sqrt(x*x+y*y))*(1-work));
				flag[x_ix][y_ix]=1;
			}
			x+=dx;
			y+=dy;
		}
	}
#endif

#if 1
	const int NOINFO_G=0;
	const int FREE_G=1;
	const int UNKNOWN_G=2;
	const int OCCUPANCY_G=3;

	for(i=0;i<Xnum;i++)for(j=0;j<Ynum;j++)flag[i][j]=NOINFO_G;

	for(i=0;i<data_num;i++){
		if(dist[i]<min_dist)continue;

		double obs_theta=theta_start+(theta_end-theta_start)/(double)(data_num-1)*(double)i+sensor.theta;
#if 0
		double x=0;
		double y=0;
		double dx=cos(obs_theta)*Grid_size/5;
		double dy=sin(obs_theta)*Grid_size/5;
#else
		double dist_work=0.0;
#endif
		int obs_x=(int)(dist[i]*cos(obs_theta)/Grid_size-Xmin/Grid_size+sensor.x/Grid_size);
		int obs_y=(int)(dist[i]*sin(obs_theta)/Grid_size-Ymin/Grid_size+sensor.y/Grid_size);

		while(/*sqrt(x*x+y*y)*/dist_work<max_dist){
#if 0
			double d=sqrt(x*x+y*y);
#else
			double x=dist_work*cos(obs_theta);
			double y=dist_work*sin(obs_theta);
#endif
			int x_ix=(int)(x/Grid_size-Xmin/Grid_size+sensor.x/Grid_size);
			int y_ix=(int)(y/Grid_size-Ymin/Grid_size+sensor.y/Grid_size);

			if(x_ix<0 || x_ix>=Xnum || y_ix <0 || y_ix>=Ynum)
				break;

			if(x_ix==obs_x && y_ix==obs_y){
				flag[x_ix][y_ix]=OCCUPANCY_G;
			}else if(dist_work<dist[i]){
				if(flag[x_ix][y_ix]==NOINFO_G){
					flag[x_ix][y_ix]=FREE_G;
				}
			}
			else{
				if(flag[x_ix][y_ix]!=OCCUPANCY_G){
					flag[x_ix][y_ix]=UNKNOWN_G;
				}
			}
#if 0
			x+=dx;
			y+=dy;
#else
			dist_work+=Grid_size/5.0;
#endif
		}
	}
	for(i=0;i<Xnum;i++){
		for(j=0;j<Ynum;j++){
			if(flag[i][j]==OCCUPANCY_G){
				double work=map[i][j];
				if(work<0.01) work=0.01;
				double work_dist=Grid_size*sqrt((double)((i+Xmin/Grid_size)*(i+Xmin/Grid_size)+(j+Ymin/Grid_size)*(j+Ymin/Grid_size)));
				map[i][j]=POE(work_dist)*work/(POE(work_dist)*work+PO_E(work_dist)*(1-work));
			}else if(flag[i][j]==FREE_G){
				double work=map[i][j];
				if(work>0.99)work=0.99;
				double work_dist=Grid_size*sqrt((double)((i+Xmin/Grid_size)*(i+Xmin/Grid_size)+(j+Ymin/Grid_size)*(j+Ymin/Grid_size)));
				map[i][j]=P_OE(work_dist)*work/(P_OE(work_dist)*work+P_O_E(work_dist)*(1-work));
			}
		}
	}

#ifdef _MASU_DEBAG_
	IplImage *debug_img=cvCreateImage(cvSize(Xnum,Ynum),8,3);
	char *wn="test";
	cvNamedWindow(wn);
	int step=debug_img->widthStep;
	for(i=0;i<Xnum;i++){
		for(j=0;j<Ynum;j++){
			debug_img->imageData[i*step+j*3+0]=(unsigned char)(map[i][j]*255);
			debug_img->imageData[i*step+j*3+1]=(unsigned char)(map[i][j]*255);
			debug_img->imageData[i*step+j*3+2]=(unsigned char)(map[i][j]*255);
		}
	}
	cvShowImage(wn,debug_img);
	cvWaitKey();
	cvReleaseImage(&debug_img);
#endif
#endif

}
