//-------------------------------------------------------------------------------------------------+
// LocalMap.h
// Ǐn}RTC̃CNX`
//-------------------------------------------------------------------------------------------------+

#ifndef LOCALMAP_H
#define LOCALMAP_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service implementation headers
#include "MRFCSVC_impl.h"

// Service Consumer stub headers
#include "LaserRangeSensorDataStub.h"
#include "IIS2Stub.h"

#include "LPM.h"


using namespace RTC;
using namespace SensorRTC;
using namespace IIS;
using namespace MRFC;


//-------------------------------------------------------------------------------------------------+
// Ǐn}RTC̃CNX
//-------------------------------------------------------------------------------------------------+
class LocalMap : public RTC::DataFlowComponentBase{
public:

	LocalMap(RTC::Manager* manager);
	~LocalMap();
	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:
	int m_LocalMapWidth;
	int m_LocalMapHeight;
	double m_LocalMapScale;
	double m_SensorX;
	double m_SensorY;
	double m_SensorMaxDistance;
	double m_SensorMinDistance;
	double m_SensorTheta;
	long int m_error_code;
	long int m_Error_mode;

	// DataInPort declaration
	LaserRangeSensor::idl::TimedMeasuredData m_rangedata;
	InPort<LaserRangeSensor::idl::TimedMeasuredData> m_rangedataIn;
	IIS::TimedPose2D m_pose;
	InPort<IIS::TimedPose2D> m_poseIn;

	// CORBA Port declaration
	RTC::CorbaPort m_RelativeMapServicePort;

	// Service declaration
	RelativeMapServiceSVC_impl m_RelativeMapService;

private:
	LPM* LocalMap_A;
	Pose Old_Pose;
	bool set_old_pose;

	// For Service ports
	CRITICAL_SECTION g_critSec;
	TimedRelativeOGMapData localmap;

	void UpdateLocalMap();
	void MakeLocalMap();
	void InitLocalMap();
	double *StoreRangeData();
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void LocalMapInit(RTC::Manager* manager);
};

#endif // LOCALMAP_H
