//------------------------------------------------------------------------------------------------+
// MRFCSVC_impl.cpp
// Service implementation code of MRFC.idl
//------------------------------------------------------------------------------------------------+

#include "MRFCSVC_impl.h"



//------------------------------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
RelativeMapServiceSVC_impl::RelativeMapServiceSVC_impl( MRFC::TimedRelativeOGMapData *localmap, CRITICAL_SECTION *cs ){

	mapdata   = localmap;
	c_section = cs;
}


//------------------------------------------------------------------------------------------------+
// fXgN^
//------------------------------------------------------------------------------------------------+
RelativeMapServiceSVC_impl::~RelativeMapServiceSVC_impl(){
}


//------------------------------------------------------------------------------------------------+
// ݒn
//------------------------------------------------------------------------------------------------+
RTC::OGMapConfig RelativeMapServiceSVC_impl::getRelativeOGMapConfig(){

	return mapdata->mapconfig;
}


//------------------------------------------------------------------------------------------------+
// Ǐn}n
//------------------------------------------------------------------------------------------------+
MRFC::TimedRelativeOGMapData *RelativeMapServiceSVC_impl::getRelativeOGMap(){

	EnterCriticalSection( c_section );

	MRFC::TimedRelativeOGMapData *localmap = new MRFC::TimedRelativeOGMapData();

	*localmap = *mapdata;

	LeaveCriticalSection( c_section );

	return localmap;
}


//------------------------------------------------------------------------------------------------+
// Ǐn}n
//------------------------------------------------------------------------------------------------+
MRFC::TimedFloatRelativeOGMapData *RelativeMapServiceSVC_impl::getFloatRelativeOGMap(){

	EnterCriticalSection( c_section );

	MRFC::TimedFloatRelativeOGMapData *localmap = new MRFC::TimedFloatRelativeOGMapData();

	localmap->mapconfig = mapdata->mapconfig;
	localmap->tm        = mapdata->tm;
	localmap->pose      = mapdata->pose;

	localmap->cells.length( mapdata->cells.length() );

	for( int i=0; i<localmap->cells.length(); i++ ) localmap->cells[i] = (float)mapdata->cells[i] * 0.01;

	LeaveCriticalSection( c_section );

	return localmap;
}
